/**************************************************************************

   THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
   ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
   THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
   PARTICULAR PURPOSE.

   Copyright (C) 2003 by SysDesk, Holger Kuehnle.  All Rights Reserved.

   File:          outmod.h

   Description:   AudioCrusher structures, defines etc.

**************************************************************************/


/**************************************************************************
   Include Files
**************************************************************************/

#include <windows.h>
#include <windowsx.h>

/**************************************************************************
   Defines
**************************************************************************/

#define OM_VERSION 1
#define OMTI_VERSION 1

/**************************************************************************
   Structures
**************************************************************************/

/* The output module track information stucture */
typedef struct _OMTRACKINFO
{
	int nVersion;			/* Structure version for compatibility */
	char *szFilename;		/* output module has to append its specific
					   file extension. */
					/* '\' appendend by definition */
	char szOutFilePath[MAX_PATH];	/* Actual filename with path */
	BYTE trackNumber;
	DWORD dwTrackLength; 		/* Track length in bytes */
	DWORD dwNumSamples;		/* Track length in samples */
	/* Waveformat of the input data */
	WORD nChannels;			/* 1=mono, 2=stereo etc. */
	DWORD nSamplesPerSec;		/* Samplerate like 44100hz etc. */
	WORD wBitsPerSample;		/* 8bit, 16bit etc. */
	/* Track information */
	char *title;			/* ID3v1 tag information */
	char *artist;			/* ... */
	char *album;			/* ... */
	char *year;			/* ... */
	char *comment;			/* ... */
	char genre;			/* ID3v1 genre ID if it is an ID3v1 genre,
					   0 otherwise */
	char *genreStr;			/* Genre, this can be an ID3v1 genre but not
  					   necessarily */

} OMTRACKINFO, *POMTRACKINFO,FAR *LPOMTRACKINFO;

/* Output module descriptor structure */
typedef struct
{
	int nVersion;			/* Structure version for compatibility */
	int nType;			/* 1=Normal external, 2=Internal */
	char *szDescription;		/* Output module name/description */
	/* Expected PCM wave format of the input data, set everything to zero if
   	   any format is supported
	   NOTE: as of AudioCrusher version 1.3 this information is unused, the
	  	 output wave format will always be 44100Hz, 16bit, Stereo */
	WORD nChannels;			/* 1=mono, 2=stereo etc. */
	DWORD nSamplesPerSec;		/* Samplerate like 44100hz etc. */
	WORD wBitsPerSample;		/* 8bit, 16bit etc. */

	HINSTANCE hInstance;		/* Handle to module instance */
	LPCTSTR lpTemplate;		/* Identifies dialog box template */
	DLGPROC lpDialogFunc;		/* Pointer to dialog box procedure  */
	DWORD (*pfnInit)();
	DWORD (*pfnEncode)(BYTE *buf,DWORD bufLen);
	DWORD (*pfnClose)();
} OUTMOD, *POUTMOD, FAR *LPOUTMOD;

